<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <script>
    $(document).ready(function () {
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $("#btn-submit-data").on("click", onBtnSubMit);

      $("#btn-clear-log").on("click",onBtnClearLog);

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm xử lý khi click nút submit()
      function onBtnSubMit() {
        "use strict"
        //tạo đối tượng
        var vPersonObject = {
          firstName: "",
          lastName: "",
          age: 0
        }
        //B1 : thu thập thông tin
        thuThapDuLieu(vPersonObject);
        //B2: kiểm tra dữ liệu hợp lệ
        var vDulieuhople = validateData(vPersonObject);
        if (vDulieuhople) {
          //B3: xử lý hiển thị
          xuLyHienThi(vPersonObject);
        }
        else{
          console.log("Dữ liệu không hợp lệs");
        }
      }

      //hàm xử lý khi click nút clearlog()
      function onBtnClearLog() {
        "use strict"
        var vPLog = $("#p-html-log");
        vPLog.html(">" +"<br>");
        vPLog.append(">"+"<br>");
        vPLog.append(">");
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm thu thập dữ liệu trên form
      function thuThapDuLieu(paramObj) {
        var vFirstNameInput = $("#inp-first-name");
        var vLastNameInput = $("#inp-last-name");
        var vAgeInput = $("#inp-age");

        paramObj.firstName = vFirstNameInput.val();
        paramObj.lastName = vLastNameInput.val();
        paramObj.age = vAgeInput.val();
      };

      //hàm kiểm tra dữ liệu
      function validateData(paramObj) {
        if (paramObj.firstName === "") {
          console.log("phải nhập vào firstname");
          return false;
        }
        if (paramObj.lastName === "") {
          console.log("phải nhập vào lastname");
          return false;
        }
        if (isNaN(paramObj.age)) {
          console.log("phải nhập vào age");
          return false;
        }
        if (paramObj.age < 0 || paramObj.age > 200) {
          console.log("Vui lòng nhập lại tuổi");
          return false;
        }
        return true;
      };

      //hàm ghi thông tin ra vùng log(Xử lý hiển thị)
      function xuLyHienThi(paramObj) {
        var vPLog = $("#p-html-log");
        vPLog.html("> firstname: " + paramObj.firstName +"<br>");
        vPLog.append("> lastname: " + paramObj.lastName +"<br>");
        vPLog.append("> age: " + paramObj.age)
      };


    });

  </script>

</head>

<body>
  <div class="container">
    <h2 style="text-align: center;">Personal Data Submit Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-first-name">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="inp-first-name" name="firstname" placeholder="Your first name ..."
            class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="inp-last-name">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="inp-last-name" name="lastname" placeholder="Your last name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="age">Age</label>
        </div>
        <div class="col-sm-9">
          <input type="number" id="inp-age" name="age" placeholder="Your age ..." class="form-control">
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button id="btn-submit-data" class="btn btn-info">Submit Data</button>
        </div>
      </div>
    </div>
    <!-- HTML Log -->
    <hr>
    <div style="text-align: right;">
      <button id="btn-clear-log" class="btn btn-info"> Clear HTML Log </button>
    </div>
    <p id="p-html-log"></p>
  </div>
</body>

</html>